﻿' Parameters: ("Main","<parDevice> | <parDrive> | <parWrite> | <parDeviceOnline>")
'--------------------------------------------------------------------------------------------------------
'                                DISKSPACE integration into HOMESEER
' 	   			   by DJF3 - http://www.domoticaworld.com - info@domoticaworld.com
'version: 0.8 - 24-Oct 2012
'		NEW architecture. Run script once per drive you want to check. All config in parameters
'		REMOVED DB writes part, using my DB write script for that (see website)
'version: 0.7 - 22-Jan 2012
'		Added little graphs instead of just an icon and text. Testing. Have to think this through.
'		FUTURE: move to .NET drive IO? http://dotnetdud.blogspot.com/2008/04/get-free-disk-space-in-all-drives-using.html
'version: 0.6 - Dec-6 2010 - changed setdevicestring adding 'TRUE' to update the last-change-date, added line for logging if Mac is turned OFF
'version: 0.6 - Jan-27 2009
'		add Megabytes-free to device VALUE 
'		Removed PING check to server. It runs anyway. Updated: only check Mac if the network status is online
' 		Updated script with new header
' 		Changed drive images to \Image folder
'		Updated drive images with transparent background.
'version: 0.5 - Dec-07 2008
' 		Moving script back to VB code
'		Added DB writes (manual configuration of MDB file using strDatabase variable)
'version: 0.4 - Xxx-00 2008
'NOTE: to get diskspace from mapped (network) drives you need to run HomeSeer under an administrator acct, NOT local system account.
'PARAMETERs
'	Device	- Device to write free space information to
'	Drive	- Drive/network_path to check for free space
'	Write	- Write to DB? yes/no
'	DeviceOnline- Device code of device that should be ONLINE (value=1) If yes, then continue, otherwise stop.	

' ==============================   MAIN   ==============================================================


sub Main(byVal parm)
Dim varVersion,strDebug,parDevice,parDrive,parWrite,parDeviceOnline as String = ""
Dim strContinue as Integer

varVersion = "0.8"
varVersion = "DJ_DriveSpace_" & varVersion 
strDebug = 1
parDevice = hs.stringitem(Parm,1,"|") 		'DJ: Device to store information in
parDrive = hs.stringitem(Parm,2,"|")		'DJ: Which Drive or network path? 
parWrite = hs.stringitem(Parm,3,"|")		'DJ: Write to DB or not?
parDeviceOnline = hs.stringitem(Parm,4,"|")	'DJ: Only check free space if this device is online (value=1)

'----- Do we have to check if another device is online (devicevalue=1) before continuing?
strContinue = 1
If ParDeviceOnline <> "" then
	If hs.devicevalue(parDeviceOnline) <> 1 then strContinue = 0
	hs.writelog(varVersion,"Device: " & parDeviceOnline & " is OFFLINE, not continuing drivespace check")
End If


If strContinue = 1 then
	Dim fso, drv, s, drivespace_total, drivespace_free, drivespace_percentage, drivespace_status, ds_icon
    	fso = CreateObject("Scripting.FileSystemObject")
	drv = fso.GetDrive(fso.GetDriveName(parDrive))
	'VAR: total drive space
	drivespace_total = FormatNumber(drv.TotalSize / 1073741824, 2)
	'VAR: free drive space
	drivespace_free = FormatNumber(drv.FreeSpace / 1073741824, 2)
	'VAR: percentage of free drive space
	drivespace_percentage = FormatNumber(((drivespace_free / drivespace_total) * 100), 0)
	'VAR: Status written to HS device status field (easy to read format like "22Gb (10%)"
	drivespace_status = FormatNumber(drivespace_free, 0) & " GB " & "(" & drivespace_percentage & "%)"
	'LOGGING: writes to HS log IF strDebug has been set to 1
	If strDebug = 1 Then
		hs.WriteLog (varVersion, "Device:" & parDevice & "   ... " & drivespace_status)
	End if

	'ICON: this section changes the icon that will be used for the HS device, based on the percentage of available space.
	'	by default I'm setting it to RED, so if all your drives look RED the script might not work correctly
	ds_icon = "\Images\hard_drive_red.gif"
	If drivespace_percentage < 10 Then
		ds_icon = "\Images\hard_drive_red2.gif"
	else
		ds_icon = "\Images\hard_drive_blue.gif"
	End if
	
	' SET: status in HS containing the free space, percentage and the icon used (red disk icon if space goes below 'ds_redifbelow' percent)
	' DJ: Below: have to change the devicestring otherwise the date-last-changed will not update if the device string doesn't change.
	hs.SetDeviceString (parDevice, "You should not see this text", TRUE)
	hs.SetDeviceString (parDevice, "<img src='" & ds_icon & "' align=absmiddle>" & " " & drivespace_status, TRUE)
	hs.SetDeviceValue  (parDevice, drivespace_percentage)

	hs.SetDeviceString (parDevice, "<img src='" & ds_icon & "' width='" & drivespace_percentage & "px' height='16px' align=absmiddle><img src='\Images\hard_drive_black.gif' width='" & (100-drivespace_percentage) & "px'  height='16px' align=absmiddle> " & drivespace_status, TRUE)
	
	'----- Write to DB if parWrite = "yes"
	If parWrite = "yes" then 
		hs.writelog(varVersion,"Writing free space to DB")
		hs.RunEx("DJ_DBlogging_05.vb","Main","Drivespace|" & parDrive & "|" & FormatNumber(drivespace_free, 0) & "|dsdate|dstime|dsdrive|dsspace") 
	End If
	
	drv = Nothing
	fso = Nothing
End If
	
	
End Sub
